#include "pch.h"

struct tagMon {
	HMONITOR hMon;
	RECT rcMon;
	BOOL bPrimary;
} arMon[10];
int MonCount;
int NowMon = 0;

BOOL CALLBACK MonitorEnumProc(HMONITOR hMonitor, HDC hdcMonitor, LPRECT lprcMonitor, LPARAM dwData)
{
	MONITORINFOEX mi;

	arMon[MonCount].hMon = hMonitor;
	arMon[MonCount].rcMon = *lprcMonitor;
	mi.cbSize = sizeof(MONITORINFOEX);
	GetMonitorInfo(hMonitor, &mi);
	arMon[MonCount].bPrimary = (mi.dwFlags & MONITORINFOF_PRIMARY);
	MonCount++;
	return TRUE;
}

// API  ״  .     
LRESULT CALLBACK LCDTest_WndProc(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;
	HBRUSH hBrush;
	RECT crt;
	LPCTSTR Mes = TEXT("LCD ׽Ʈ α׷\r\n Ŭ, ̽: ,  Ŭ, M: ̵\r\n")
		TEXT("Esc:,Enter:ȳ ڿ RGBWK:  ");
	int sx, sy;
	static int idx = 2;
	static COLORREF col[] = { RGB(255,0,0),RGB(0,255,0),RGB(0,0,255),
		RGB(255,255,255),RGB(0,0,0) };
	static bool displayText = true;

	switch (iMessage) {
	case WM_CREATE:
		// ִ ũ Ȯ
		sx = GetSystemMetrics(SM_CXSCREEN);
		sy = GetSystemMetrics(SM_CYSCREEN);
		MoveWindow(hWnd, 0, 0, sx, sy, TRUE);
		return 0;
	case WM_LBUTTONDOWN:
		SendMessage(hWnd, WM_USER + 1, 0, 0);
		return 0;
	case WM_RBUTTONDOWN:
		SendMessage(hWnd, WM_USER + 2, 0, 0);
	case WM_USER + 1:
		idx = idx == Count(col) - 1 ? 0 : idx + 1;
		InvalidateRect(hWnd, NULL, FALSE);
		return 0;
	case WM_USER + 2:
		if (GetSystemMetrics(SM_CMONITORS) > 1) {
			MonCount = 0;
			EnumDisplayMonitors(NULL, NULL, MonitorEnumProc, (LPARAM)NULL);
			if (MonCount > 1) {
				NowMon = (NowMon == MonCount - 1 ? 0 : NowMon + 1);
				MoveWindow(hWnd, arMon[NowMon].rcMon.left, arMon[NowMon].rcMon.top,
					arMon[NowMon].rcMon.right - arMon[NowMon].rcMon.left,
					arMon[NowMon].rcMon.bottom - arMon[NowMon].rcMon.top, TRUE);
			}
		}
		return 0;
	case WM_KEYDOWN:
		switch (wParam) {
		case VK_SPACE:
			SendMessage(hWnd, WM_USER + 1, 0, 0);
			break;
		case VK_ESCAPE:
			DestroyWindow(hWnd);
			break;
		case VK_RETURN:
			displayText = !displayText;
			InvalidateRect(hWnd, NULL, FALSE);
			break;
		case 'R':
			idx = 0;
			InvalidateRect(hWnd, NULL, FALSE);
			break;
		case 'G':
			idx = 1;
			InvalidateRect(hWnd, NULL, FALSE);
			break;
		case 'B':
			idx = 2;
			InvalidateRect(hWnd, NULL, FALSE);
			break;
		case 'W':
			idx = 3;
			InvalidateRect(hWnd, NULL, FALSE);
			break;
		case 'K':
			idx = 4;
			InvalidateRect(hWnd, NULL, FALSE);
			break;
		case 'M':
			SendMessage(hWnd, WM_USER + 2, 0, 0);
			break;
		}
		return 0;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		hBrush = CreateSolidBrush(col[idx]);
		GetClientRect(hWnd, &crt);
		FillRect(hdc, &crt, hBrush);
		DeleteObject(hBrush);

		if (displayText) {
			if (idx == 4) {
				SetTextColor(hdc, RGB(255, 255, 255));
			}
			SetBkMode(hdc, TRANSPARENT);
			crt.top = crt.bottom / 2;
			DrawText(hdc, Mes, -1, &crt, DT_CENTER);
		}
		EndPaint(hWnd, &ps);
		return 0;
	case WM_DESTROY:
		return 0;
	}
	return(DefWindowProc(hWnd, iMessage, wParam, lParam));
}

LRESULT CALLBACK SizeMeter_WndProc(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;
	TCHAR str[111];
	RECT crt;
	int w, h;

	switch (iMessage) {
	case WM_CREATE:
		return 0;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		GetClientRect(hWnd, &crt);
		wsprintf(str, TEXT("%d x %d"), crt.right, crt.bottom);
		SetBkMode(hdc, TRANSPARENT);
		SetTextAlign(hdc, TA_CENTER);
		// DrawText(hdc, str, -1, &crt, DT_CENTER | DT_VCENTER);
		TextOut(hdc, crt.right / 2, crt.bottom / 2, str, lstrlen(str));
		lstrcpy(str, TEXT("1 ~ 9 : ǥ ũ"));
		TextOut(hdc, crt.right / 2, crt.bottom / 2 + 30, str, lstrlen(str));
		EndPaint(hWnd, &ps);
		return 0;
	case WM_SIZE:
		InvalidateRect(hWnd, NULL, TRUE);
		return 0;
	case WM_KEYDOWN:
		w = 0;
		switch (wParam) {
		case '1':
			w = 320;
			h = 240;
			break;
		case '2':
			w = 640;
			h = 480;
			break;
		case '3':
			w = 800;
			h = 600;
			break;
		case '4':
			w = 1024;
			h = 768;
			break;
		case '5':
			w = 1280;
			h = 1024;
			break;
		case '6':
			w = 1600;
			h = 1200;
			break;
		case '7':
			w = 1920;
			h = 1080;
			break;
		case '8':
			w = 2560;
			h = 1440;
			break;
		case '9':
			w = 3840;
			h = 2160;
			break;
		}
		if (w != 0)
		{
			SetRect(&crt, 0, 0, w, h);
			DWORD Style = GetWindowLong(hWnd, GWL_STYLE);
			DWORD ExStyle = GetWindowLong(hWnd, GWL_EXSTYLE);

			AdjustWindowRectEx(&crt, Style, GetMenu(hWnd) != NULL, ExStyle);
			SetWindowPos(hWnd, NULL, 0, 0, crt.right - crt.left, crt.bottom - crt.top,
				SWP_NOMOVE | SWP_NOZORDER);
		}
		return 0;
	case WM_DESTROY:
		return 0;
	}
	return(DefWindowProc(hWnd, iMessage, wParam, lParam));
}

LRESULT CMoveCursor::OnCreate(WPARAM wParam, LPARAM lParam) {
	hBtn = CreateWindow(TEXT("GrpBtn"), NULL, WS_CHILD | WS_VISIBLE | GBS_CHECK,
		0, 0, iconSize, iconSize, hWnd, (HMENU)1, g_hInst, NULL);
	// NORMAL On, Down Off
	SendMessage(hBtn, GBM_SETIMAGE, MAKEWPARAM(IDB_CURSORON, IDB_CURSORON),
		MAKEWPARAM(IDB_CURSOROFF, IDB_CURSORON));

	// todo : INI Ͽ ʱ  
	bCursorMove = true;
	CursorInterval = 180;
	// Ÿ̸Ӵ ̵ֱ 1/10 ڵ Ѵ. 180ʸ 18ʿ ѹ Ȯϸ ϴ.
	//  ɼ µ ڰ ̷    ʿ . 
	TimerInterval = CursorInterval * 100;
	CursorKeepSec = 0;
	RejectCount = 0;
	if (bCursorMove) {
		SendMessage(hBtn, GBM_SETSTATE, GB_NORMAL, 0);
		SetTimer(hWnd, 1, TimerInterval, NULL);
	} else {
		SendMessage(hBtn, GBM_SETSTATE, GB_DOWN, 0);
	}
	return 0;
}

LRESULT CMoveCursor::OnCommand(WPARAM wParam, LPARAM lParam) {
	if (LOWORD(wParam) == 1) {
		if (SendMessage(hBtn, GBM_GETSTATE, 0, 0) == GB_DOWN) {
			bCursorMove = false;
			KillTimer(hWnd, 1);
		} else {
			bCursorMove = true;
			SetTimer(hWnd, 1, TimerInterval, NULL);
		}
	}
	return 0;
}

LRESULT CMoveCursor::OnTimer(WPARAM wParam, LPARAM lParam)
{
	POINT pt;

	GetCursorPos(&pt);
	//  ڸ ִ  ð  
	if (pt.x == OldCursorPt.x && pt.y == OldCursorPt.y) {
		CursorKeepSec += TimerInterval / 1000;
		// ũ ̹  ð Ǹ  Ŀ ĭ  ű 
		if (CursorKeepSec >= CursorInterval) {
			CursorKeepSec = 0;
			mouse_event(MOUSEEVENTF_MOVE, 1, 0, 0, 0);
			RejectCount++;
		}
		// ġ ٲ  ð  
	} else {
		CursorKeepSec = 0;
		OldCursorPt = pt;
	}
	return 0;
}

BOOL CALLBACK MoveCursorDlgProc(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	static CMoveCursor* pMc;
	TCHAR str[128];

	switch (iMessage) {
	case WM_INITDIALOG:
		// todo : θ ġ ʴ  ڵ ̵

		//  ݴ   , Ʒ ̴. 
		SendDlgItemMessage(hDlg, IDC_SPINMOVECURSORCYCLE, UDM_SETRANGE, 0, MAKELPARAM(600, 60));

		pMc = (CMoveCursor*)lParam;
		wsprintf(str, L"̵ Ƚ : %d", pMc->RejectCount);
		SetDlgItemText(hDlg, IDC_STMOVECURSORCOUNT, str);
		if (pMc->bCursorMove) {
			CheckDlgButton(hDlg, IDC_CHKMOVECURSOR, BST_CHECKED);
		}
		SetDlgItemInt(hDlg, IDC_EDMOVECURSORCYCLE, pMc->CursorInterval, FALSE);
		return TRUE;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDOK:
			pMc->CursorInterval = GetDlgItemInt(hDlg, IDC_EDMOVECURSORCYCLE, NULL, FALSE);
			pMc->TimerInterval = pMc->CursorInterval * 100;
			if (IsDlgButtonChecked(hDlg, IDC_CHKMOVECURSOR) == BST_CHECKED) {
				pMc->bCursorMove = true;
				SetTimer(pMc->hWnd, 1, pMc->TimerInterval, NULL);
			} else {
				pMc->bCursorMove = false;
				KillTimer(pMc->hWnd, 1);
			}
			EndDialog(hDlg, IDOK);
			return TRUE;
		case IDCANCEL:
			EndDialog(hDlg, IDCANCEL);
			return TRUE;
		}
		break;
	}
	return FALSE;
}

LRESULT CMoveCursor::OnContextMenu(WPARAM wParam, LPARAM lParam)
{
	DialogBoxParam(g_hInst, MAKEINTRESOURCE(IDD_MOVECURSOR), hWnd, MoveCursorDlgProc, (LPARAM)this);
	return 0;
}

