#include "pch.h"

void CClock::OnPaint(HDC hdc, RECT crt) {
	SYSTEMTIME st;
	TCHAR sTime[128];
	static TCHAR arYoil[][4] = { TEXT(""), TEXT(""), TEXT("ȭ"), TEXT(""), TEXT(""), TEXT(""), TEXT("") };
	HFONT font, oldfont;

	SetBkMode(hdc, TRANSPARENT);
	SetTextAlign(hdc, TA_CENTER);
	GetLocalTime(&st);
	wsprintf(sTime, TEXT("%d%d %s"), st.wMonth, st.wDay, arYoil[st.wDayOfWeek]);
	TextOut(hdc, crt.right / 2, 10, sTime, lstrlen(sTime));
	font = CreateFont(25, 0, 0, 0, 0, 0, 0, 0, ANSI_CHARSET, 3, 2, 1,
		VARIABLE_PITCH | FF_SWISS, TEXT("Arial"));
	oldfont = (HFONT)SelectObject(hdc, font);

	int hour = st.wHour;
	if (hour24 == false) {
		//  0,  12÷ ǥѴ.
		if (hour > 12) {
			hour -= 12;
		}
	}

	TCHAR sDigit[128];
	if (digit2) {
		lstrcpy(sDigit, L"%02d");
	} else {
		lstrcpy(sDigit, L"%d");
	}

	TCHAR sFormat[128];
	lstrcpy(sFormat, sDigit);
	lstrcat(sFormat, L":");
	lstrcat(sFormat, sDigit);
	if (outSec) {
		lstrcat(sFormat, L":");
		lstrcat(sFormat, sDigit);
		wsprintf(sTime, sFormat, hour, st.wMinute, st.wSecond);
	} else {
		wsprintf(sTime, sFormat, hour, st.wMinute);
	}

	TextOut(hdc, crt.right / 2, 35, sTime, lstrlen(sTime));
	SelectObject(hdc, oldfont);
	DeleteObject(font);
}

LRESULT CCpuUsage::OnTimer(WPARAM wParam, LPARAM lParam) {
	PDH_FMT_COUNTERVALUE counterVal;

	//  ĭ ֱٰ 
	PdhCollectQueryData(cpuQuery);
	PdhGetFormattedCounterValue(cpuTotal, PDH_FMT_DOUBLE, NULL, &counterVal);

	// ϳ  ̵ϰ  ֱٰ 
	for (int i = 1; i < USAGE_NUM; i++) {
		arUsage[i - 1] = arUsage[i];
	}
	// ݿøؼ  Ѵ. 
	arUsage[USAGE_NUM - 1] = (int)(counterVal.doubleValue + 0.5);
#ifdef _DEBUG
	arUsage[USAGE_NUM - 1] += 20;
#endif

	InvalidateRect(hWnd, NULL, TRUE);
	return 0;
}

void CCpuUsage::OnPaint(HDC hdc, RECT crt) {
	int width, height;
	RECT trt;
	POINT pts[USAGE_NUM + 3];
	int Min = 100, Max = 0, Sum = 0, Avg;
	HPEN hPen, OldPen;
	HBRUSH hBrush, OldBrush;
	HFONT OldFont;

	SetBkMode(hdc, TRANSPARENT);

	GetClientRect(hWnd, &crt);
	trt.left = crt.left + 5;
	trt.top = crt.top + 5;
	trt.right = crt.right - 5;
	trt.bottom = crt.bottom - 35;
	width = (trt.right - trt.left);
	height = (trt.bottom - trt.top);

	//  ä
	hPen = CreatePen(PS_SOLID, 1, RGB(16, 80, 160));
	OldPen = (HPEN)SelectObject(hdc, hPen);
	hBrush = CreateSolidBrush(RGB(240, 240, 255));
	OldBrush = (HBRUSH)SelectObject(hdc, hBrush);
	Rectangle(hdc, trt.left, trt.top, trt.right, trt.bottom);
	SelectObject(hdc, OldPen);
	DeleteObject(hPen);
	SelectObject(hdc, OldBrush);
	DeleteObject(hBrush);

	// ٵ ׸
	hPen = CreatePen(PS_SOLID, 1, RGB(220, 220, 255));
	OldPen = (HPEN)SelectObject(hdc, hPen);
	for (int i = 1; i <= 3; i++) {
		MoveToEx(hdc, trt.left + 1, trt.top + height * i / 4, NULL);
		LineTo(hdc, trt.right - 1, trt.top + height * i / 4);
	}
	for (int i = 1; i <= 5; i++) {
		MoveToEx(hdc, trt.left + width * i / 6, trt.top + 1, NULL);
		LineTo(hdc, trt.left + width * i / 6, trt.bottom - 1);
	}
	SelectObject(hdc, OldPen);
	DeleteObject(hPen);

	for (int i = 0; i < USAGE_NUM; i++) {
		pts[i].x = trt.left + LONG((double)width / USAGE_NUM * i);
		pts[i].y = trt.top + height - height * arUsage[i] / 100;

		Min = min(Min, arUsage[i]);
		Max = max(Max, arUsage[i]);
		Sum = Sum + arUsage[i];
	}
	Avg = Sum / USAGE_NUM;
	pts[USAGE_NUM].x = pts[USAGE_NUM - 1].x;
	pts[USAGE_NUM].y = trt.top + height;
	pts[USAGE_NUM + 1].x = trt.left;
	pts[USAGE_NUM + 1].y = trt.top + height;
	pts[USAGE_NUM + 2].x = pts[0].x;
	pts[USAGE_NUM + 2].y = pts[0].y;

	Polygon(hdc, pts, USAGE_NUM + 3);

	TCHAR sUsage[128];

	wsprintf(sUsage, TEXT("%d~%d:%d - %d"), Min, Max, Avg, arUsage[USAGE_NUM - 1]);
	OldFont = (HFONT)SelectObject(hdc, mainFont);
	TextOut(hdc, trt.left, trt.bottom + 2, sUsage, lstrlen(sUsage));
	SelectObject(hdc, OldFont);
}

LRESULT CMemUsage::OnTimer(WPARAM wParam, LPARAM lParam) {
	MEMORYSTATUSEX mem;
	mem.dwLength = sizeof(MEMORYSTATUSEX);
	GlobalMemoryStatusEx(&mem);
	TCHAR str[128];
	double total = mem.ullTotalPhys / 1073741824.0;
	double avail = mem.ullAvailPhys / 1073741824.0;
	double used = total - avail;
	//  : Ǽ ý _stprintf SDL ˻ ɼ    . 
	_stprintf_s(str, TEXT("%.1fG / %.1fG(%d%%)"), used, total, mem.dwMemoryLoad);
	SetWindowText(hStMem, str);
	return 0;
}

LRESULT CBattery::OnTimer(WPARAM wParam, LPARAM lParam)
{
	GetSystemPowerStatus(&sps);
	InvalidateRect(hWnd, NULL, TRUE);
	return 0;
}

void CBattery::OnPaint(HDC hdc, RECT crt)
{
	SetBkMode(hdc, TRANSPARENT);
	SetTextAlign(hdc, TA_CENTER);
	HFONT OldFont, font;
	HBRUSH brush, oldbrush;
	brush = CreateSolidBrush(RGB(255, 0, 0));

	TCHAR ac[128];
	TCHAR remain[128] = L"";
	TCHAR percent[128];
	if (sps.ACLineStatus) {
		lstrcpy(ac, L"");
	} else {
		lstrcpy(ac, L"͸");
		if (sps.BatteryLifeTime != (DWORD)-1) {
			if (sps.BatteryLifeTime >= 3600) {
				wsprintf(remain, L"%d:%d", sps.BatteryLifeTime / 3600, sps.BatteryLifeTime % 3600 / 60);
			} else {
				wsprintf(remain, L"%d", sps.BatteryLifeTime % 3600 / 60);
			}
		}
	}
	wsprintf(percent, L"%d%%", sps.BatteryLifePercent);

	if (bVertical) {
		OldFont = (HFONT)SelectObject(hdc, mainFont);
		if (lstrlen(remain) == 0) {
			TextOut2(hdc, 25, crt.bottom / 2 - 7/*Ʈ*/, ac);
		} else {
			TextOut2(hdc, 25, crt.bottom / 2 - 15/*Ʈ*/, ac);
			TextOut2(hdc, 25, crt.bottom / 2, remain);
		}
		SelectObject(hdc, OldFont);

		// ¿ ڿ    20 ߾ 
		Rectangle(hdc, 50, crt.bottom / 2 - 10, crt.right - 50, crt.bottom / 2 + 10);
		int width = crt.right - 104;
		int gaugewidth = sps.BatteryLifePercent * width / 100;
		oldbrush = (HBRUSH)SelectObject(hdc, brush);
		Rectangle(hdc, 52, crt.bottom / 2 - 10 + 2, 52 + gaugewidth, crt.bottom / 2 + 10 - 2);
		SelectObject(hdc, oldbrush);

		font = CreateFont(20, 0, 0, 0, 0, 0, 0, 0, ANSI_CHARSET, 3, 2, 1,
			VARIABLE_PITCH | FF_SWISS, TEXT("Arial"));
		OldFont = (HFONT)SelectObject(hdc, font);
		TextOut2(hdc, crt.right - 25, crt.bottom / 2 - 10/*Ʈ*/, percent);
		SelectObject(hdc, OldFont);
		DeleteObject(font);
	} else {
		OldFont = (HFONT)SelectObject(hdc, mainFont);
		if (lstrlen(remain) == 0) {
			TextOut2(hdc, crt.right / 4, crt.bottom / 4, ac);
		} else {
			TextOut2(hdc, crt.right / 4, crt.bottom / 4 - 7/*Ʈ*/, ac);
			TextOut2(hdc, crt.right / 4, crt.bottom / 4 + 7/*Ʈ*/, remain);
		}
		SelectObject(hdc, OldFont);

		int gcenter = crt.right * 3 / 4;
		Rectangle(hdc, gcenter - 10, 5, gcenter + 10, crt.bottom - 5);
		int height = crt.bottom - 14;
		int gaugeheight = sps.BatteryLifePercent * height / 100;
		oldbrush = (HBRUSH)SelectObject(hdc, brush);
		Rectangle(hdc, gcenter - 8, crt.bottom - 5 - gaugeheight, gcenter + 8, crt.bottom - 5);
		SelectObject(hdc, oldbrush);

		font = CreateFont(20, 0, 0, 0, 0, 0, 0, 0, ANSI_CHARSET, 3, 2, 1,
			VARIABLE_PITCH | FF_SWISS, TEXT("Arial"));
		OldFont = (HFONT)SelectObject(hdc, font);
		TextOut2(hdc, crt.right / 4, crt.bottom / 2, percent);
		SelectObject(hdc, OldFont);
		DeleteObject(font);
	}

	DeleteObject(brush);
	SelectObject(hdc, OldFont);
}

//      Լ
static WNDPROC CalcOldEditProc;
double CalcExp(TCHAR* exp, BOOL* bError/*=NULL*/);
double CalcPostfix(TCHAR* Post);
void MakePostfix(TCHAR* Post, TCHAR* Mid);
int GetPriority(int op);
LRESULT CALLBACK EditProc(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam);

LRESULT CCalc::OnMessage(UINT iMessage, WPARAM wParam, LPARAM lParam) {
	TCHAR sExp[256];
	double Result;
	BOOL bError;
	TCHAR sResult[128];

	switch (iMessage)
	{
	case WM_CTLCOLORSTATIC:
		if ((HWND)lParam == hStResult) {
			SetTextColor((HDC)wParam, RGB(0, 0, 0));
			SetBkColor((HDC)wParam, color);
			return (LRESULT)backBrush;
		}
		break;
	case WM_USER+1:
		GetWindowText(hCbExp, sExp, 256);
		Result = CalcExp(sExp, &bError);
		if (bError) {
			SetWindowText(hStResult, L" ߸Ǿϴ.");
		} else {
			// ޺ Ͽ .    INI Ͽ   δ ͵   . 
			SendMessage(hCbExp, CB_INSERTSTRING, 0, (LPARAM)sExp);

			// todo : Ǽ   ߶ 
			_stprintf_s(sResult, TEXT("= %f"), Result);
			SetWindowText(hStResult, sResult);
		}
		return 0;
	}

	return CWindow::OnMessage(iMessage, wParam, lParam);
}

LRESULT CCalc::OnCreate(WPARAM wParam, LPARAM lParam) {
	hCbExp = CreateWindow(TEXT("combobox"), TEXT(""), WS_CHILD | WS_VISIBLE | CBS_DROPDOWN | CBS_AUTOHSCROLL,
		2, 2, 160, 125, hWnd, (HMENU)1, g_hInst, NULL);
	SendMessage(hCbExp, WM_SETFONT, (WPARAM)mainFont, MAKELPARAM(FALSE, 0));
	// ޺  Ʈ ŬϿ EnterŰ Է Ѵ.
	hEdit=GetWindow(hCbExp,GW_CHILD);
	CalcOldEditProc = (WNDPROC)SetWindowLongPtr(hEdit, GWLP_WNDPROC, (LONG_PTR)EditProc);
	hStResult = CreateWindow(TEXT("static"), TEXT("=0"), WS_CHILD | WS_VISIBLE,
		2, 32, 160, 25, hWnd, (HMENU)2, g_hInst, NULL);
	SendMessage(hStResult, WM_SETFONT, (WPARAM)mainFont, MAKELPARAM(FALSE, 0));
	return 0;
}

LRESULT CCalc::OnSize(WPARAM wParam, LPARAM lParam)
{
	// ϴ θ ޼带  ȣϿ Ʈ óѴ.
	CWindow::OnSize(wParam, lParam);

	RECT crt;
	GetClientRect(hWnd, &crt);

	//  ߾ ϵ  ּ 2ȼ . 
	int y = (crt.bottom - 52) / 2;
	if (y < 2) y = 2;
	MoveWindow(hCbExp, 2, y, crt.right - 4, 125, TRUE);
	y += 25 + 2;
	MoveWindow(hStResult, 2, y, crt.right - 4, 25, TRUE);

	return 0;
}

LRESULT CALLBACK EditProc(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	switch (iMessage) {
	case WM_KEYDOWN:
		if (wParam == VK_RETURN) {
			PostMessage(GetParent(GetParent(hWnd)), WM_USER + 1, 0, 0);
			return 0;
		}
		break;
	case WM_KEYUP:
	case WM_CHAR:
		if (wParam == VK_RETURN) {
			return 0;
		}
		break;
	}

	return CallWindowProc(CalcOldEditProc, hWnd, iMessage, wParam, lParam);
}

int GetPriority(int op)
{
	switch (op) {
	case '(':
		return 0;
	case '+':
	case '-':
		return 1;
	case '*':
	case '/':
		return 2;
	case '^':
		return 3;
	}
	return 100;
}

void MakePostfix(TCHAR* Post, TCHAR* Mid)
{
	TCHAR *m = Mid;
	TCHAR *p = Post, c;
	TStack<TCHAR> cS(256);

	while (*m) {
		//  - ״ ϰ ڿ  ϳ Ѵ.
		if (isdigit(*m)) {
			while (isdigit(*m) || *m == '.') *p++ = *m++;
			*p++ = ' ';
		} else
			//  - ÿ ִ ڱ⺸  ڸ   ϰ ڽ ǪѴ.
			if (strchr("^*/+-", *m)) {
				while (cS.GetTop() != -1 && GetPriority(cS.GetValue(cS.GetTop())) >=
					GetPriority(*m)) {
					*p++ = cS.Pop();
				}
				cS.Push(*m++);
			} else
				//  ȣ - ǪѴ.
				if (*m == '(') {
					cS.Push(*m++);
				} else
					// ݴ ȣ -  ȣ   ؼ ϰ  ȣ .
					if (*m == ')') {
						for (;;) {
							c = cS.Pop();
							if (c == '(') break;
							*p++ = c;
						}
						m++;
					} else {
						m++;
					}
	}
	// ÿ  ڵ  .
	while (cS.GetTop() != -1) {
		*p++ = cS.Pop();
	}
	*p = 0;
}

double CalcPostfix(TCHAR *Post)
{
	TCHAR* p = Post;
	double num;
	double left, right;
	TStack<double> dS(256);

	while (*p) {
		// ڴ ÿ ִ´.
		if (isdigit(*p)) {
			num = _ttof(p);
			dS.Push(num);
			for (; isdigit(*p) || *p == '.'; p++) { ; }
		} else {
			// ڴ ÿ    ϰ ٽ ǪѴ.
			if (strchr("^*/+-", *p)) {
				right = dS.Pop();
				left = dS.Pop();
				switch (*p) {
				case '+':
					dS.Push(left + right);
					break;
				case '-':
					dS.Push(left - right);
					break;
				case '*':
					dS.Push(left * right);
					break;
				case '/':
					if (right == 0.0) {
						dS.Push(0.0);
					} else {
						dS.Push(left / right);
					}
					break;
				case '^':
					dS.Push(pow(left, right));
					break;
				}
			}
			//   Ǵ ڰ ƴ   ڷ
			p++;
		}
	}
	if (dS.GetTop() != -1) {
		num = dS.Pop();
	} else {
		num = 0.0;
	}
	return num;
}

double CalcExp(TCHAR* exp, BOOL* bError/*=NULL*/)
{
	TCHAR Post[256];
	TCHAR *p;
	int count;

	// ȣ ¦ ´ Ȯ.
	// todo : ,  ܿ ʿ  ִ Ȯ 
	if (bError != NULL) {
		for (p = exp, count = 0; *p; p++) {
			if (*p == '(') count++;
			if (*p == ')') count--;
		}
		*bError = (count != 0);
	}

	MakePostfix(Post, exp);
	return CalcPostfix(Post);
}
