class CWidget : public CWindow
{
public:
	CWidget(LPCTSTR name, LPCTSTR id, int minHeight, int maxHeight, int initHeight,
		COLORREF initColor, int minWidth, int maxWidth, int initWidth) {
		lstrcpy(this->name, name);
		lstrcpy(this->id, id);
		this->minHeight = minHeight;
		this->maxHeight = maxHeight;
		this->initHeight = initHeight;
		this->initColor = initColor;
		this->minWidth = minWidth;
		this->maxWidth = maxWidth;
		this->initWidth = initWidth;
	}

	TCHAR name[32];
	TCHAR id[32];

	// ʱ . ½ÿ   
	int minHeight, maxHeight;		//  
	int initHeight;					// ʱ 
	COLORREF initColor;				// 
	int minWidth, maxWidth;			// ʺ 
	int initWidth;					// ʱ ʺ,  ʺ
};

class CClock : public CWidget
{
public:
	bool hour24;
	bool outSec;
	bool digit2;
	CClock(int order, LPCTSTR name, LPCTSTR id, int minHeight, int maxHeight, int initHeight,
		COLORREF initColor, int minWidth, int maxWidth, int initWidth)
		: CWidget(name, id, minHeight, maxHeight, initHeight, initColor, minWidth, maxWidth, initWidth) {
		// todo : INI Ͽ  
		hour24 = false;
		outSec = true;
		digit2 = false;
	}

	LRESULT OnMessage(UINT iMessage, WPARAM wParam, LPARAM lParam) {
		// θ ó ʴ ޽ ϰ 켱 óѴ.
		switch (iMessage)
		{
		case WM_LBUTTONDOWN:
			return 0;
		}

		// ⺻ ޽ θ   Լ ȣѴ. 
		return CWindow::OnMessage(iMessage, wParam, lParam);
	}

	// ª ޽ ζ óѴ.
	LRESULT OnCreate(WPARAM wParam, LPARAM lParam) {
		SetTimer(hWnd, 1, 1000, NULL);
		return 0;
	}

	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam) {
		KillTimer(hWnd, 1);
		return 0;
	}

	LRESULT OnTimer(WPARAM wParam, LPARAM lParam) {
		InvalidateRect(hWnd, NULL, TRUE);
		return 0;
	}

	//  ޼ ܺ Լ Ѵ. OnPaint  Լ ϸ ܺο Ѵ. 
	void OnPaint(HDC hdc, RECT crt);
};

class CCpuUsage : public CWidget
{
public:
	static const int USAGE_NUM = 60;
	int arUsage[USAGE_NUM];
	PDH_HQUERY cpuQuery;
	PDH_HCOUNTER cpuTotal;

	CCpuUsage(int order, LPCTSTR name, LPCTSTR id, int minHeight, int maxHeight, int initHeight,
		COLORREF initColor, int minWidth, int maxWidth, int initWidth)
		: CWidget(name, id, minHeight, maxHeight, initHeight, initColor, minWidth, maxWidth, initWidth) {
	}

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam) {
		SetTimer(hWnd, 1, 2000, NULL);
		PdhOpenQuery(NULL, NULL, &cpuQuery);
		PdhAddCounter(cpuQuery, TEXT("\\Processor(_Total)\\% Processor Time"), NULL, &cpuTotal);
		PdhCollectQueryData(cpuQuery);

		memset(arUsage, 0, sizeof(arUsage));
		return 0;
	}

	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam) {
		KillTimer(hWnd, 1);
		return 0;
	}

	LRESULT OnTimer(WPARAM wParam, LPARAM lParam);
	void OnPaint(HDC hdc, RECT crt);
};

class CMemUsage : public CWidget
{
public:
	HWND hStMem;
	CMemUsage(int order, LPCTSTR name, LPCTSTR id, int minHeight, int maxHeight, int initHeight,
		COLORREF initColor, int minWidth, int maxWidth, int initWidth)
		: CWidget(name, id, minHeight, maxHeight, initHeight, initColor, minWidth, maxWidth, initWidth) {
	}

	LRESULT OnMessage(UINT iMessage, WPARAM wParam, LPARAM lParam) {
		switch (iMessage)
		{
		case WM_CTLCOLORSTATIC:
			if ((HWND)lParam == hStMem) {
				SetTextColor((HDC)wParam, RGB(0, 0, 0));
				SetBkColor((HDC)wParam, color);
				return (LRESULT)backBrush;
			}
			break;
		}

		// ⺻ ޽ θ   Լ ȣѴ. 
		return CWindow::OnMessage(iMessage, wParam, lParam);
	}

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam) {
		hStMem = CreateWindow(TEXT("static"), TEXT("Mem"), WS_CHILD | WS_VISIBLE,
			2, 2, 160, 25, hWnd, (HMENU)1, g_hInst, NULL);
		SendMessage(hStMem, WM_SETFONT, (WPARAM)mainFont, MAKELPARAM(FALSE, 0));
		SetTimer(hWnd, 1, 10000, NULL);
		SendMessage(hWnd, WM_TIMER, 1, 0);
		return 0;
	}

	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam) {
		KillTimer(hWnd, 1);
		return 0;
	}

	LRESULT OnTimer(WPARAM wParam, LPARAM lParam);
};

class CBattery : public CWidget
{
public:
	HWND hStMem;
	SYSTEM_POWER_STATUS sps;

	CBattery(int order, LPCTSTR name, LPCTSTR id, int minHeight, int maxHeight, int initHeight,
		COLORREF initColor, int minWidth, int maxWidth, int initWidth)
		: CWidget(name, id, minHeight, maxHeight, initHeight, initColor, minWidth, maxWidth, initWidth) {
	}

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam) {
		SetTimer(hWnd, 1, 10000, NULL);
		SendMessage(hWnd, WM_TIMER, 1, 0);
		return 0;
	}

	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam) {
		KillTimer(hWnd, 1);
		return 0;
	}

	LRESULT OnTimer(WPARAM wParam, LPARAM lParam);
	void OnPaint(HDC hdc, RECT crt);
};

class CCalc : public CWidget
{
public:
	HWND hCbExp;
	HWND hEdit;
	HWND hStResult;
	CCalc(int order, LPCTSTR name, LPCTSTR id, int minHeight, int maxHeight, int initHeight,
		COLORREF initColor, int minWidth, int maxWidth, int initWidth)
		: CWidget(name, id, minHeight, maxHeight, initHeight, initColor, minWidth, maxWidth, initWidth) {
	}

	LRESULT OnMessage(UINT iMessage, WPARAM wParam, LPARAM lParam);
	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnSize(WPARAM wParam, LPARAM lParam);
};

template<typename T>
class TStack
{
protected:
	T* Stack;
	int Size;
	int Top;

public:
	TStack(int aSize) {
		Size = aSize;
		Stack = (T*)malloc(Size * sizeof(T));
		Top = -1;
	}
	virtual ~TStack() {
		free(Stack);
	}
	virtual BOOL Push(T data) {
		if (Top < Size - 1) {
			Top++;
			Stack[Top] = data;
			return TRUE;
		} else {
			return FALSE;
		}
	}
	virtual T Pop() {
		return Stack[Top--];
	}
	virtual int GetTop() { return Top; }
	virtual T GetValue(int n) { return Stack[n]; }
};

